import controlP5.*;
import traer.physics.*;
import processing.opengl.*;

ControlP5 controlP5;
MultiList menu1;
PFont font;

int centerPart = 100;
int ringPart = 10;
Particle[][] net = new Particle[centerPart][ringPart];
float[] shaderG = new float[centerPart];
float[] shaderB = new float[centerPart];
ParticleSystem physics;

int myColorBackground = color(0,0,0);
int name,occu = 0;
Toggle artistT, teacherT, studentT, curatorT, entrepT, organT, inventT, writerT;
String memtemp;

String[][] textValue = new String[100][3];
String[] loadup = new String[300];


Textfield myTextfield;
Textfield myMemory;
Textarea memorySpace;

void setup() {
  font = loadFont("CenturyGothic-Italic-48.vlw");
  size(screen.width, screen.height, OPENGL);
  frameRate(30);
  
  loadup = loadStrings("lines.txt");
  for(int m = 0; m < loadup.length; m++) {
   if(loadup[m] != "null") {
     textValue[int(m/3)][m%3] = loadup[m];
     name = int(m/3) + 1;
   }
  }
  

physics = new ParticleSystem(0, 0.01);

  for(int i = 0; i < centerPart; i++) {
    shaderG[i] = random(100, 255);
    shaderB[i] = random(100, 255);
    net[i][0] = physics.makeParticle(10, random(width), random(height), 0); //make the center particle
    for(int j = 1; j < ringPart; j++) {
      net[i][j] = physics.makeParticle(2, cos((2*PI/(ringPart - 1))*j)*50 + net[i][0].position().x(), sin((2*PI/(ringPart - 1))*j)*50 + net[i][0].position().y(), 0);
      physics.makeSpring(net[i][0], net[i][j], 0.1, 0.5, (random(100, 200))); //make spring out to each ring particle from the center
      //physics.makeAttraction(net[i][0], net[i][j], -.5, 2);
    }
    //this is commented out but it connects all the ring points to each other
    for(int j = 2; j <= ringPart; j++) {  
      if(j < ringPart) {
        physics.makeSpring(net[i][j-1], net[i][j], .01, 0.1, 50);
        //println("spring" +j);
      }else {
        physics.makeSpring(net[i][j-1], net[i][1], .01, 0.1, 50);
        //println("lastspring");
      }
    }
    for(int j = 1; j < ringPart; j++) { 
     for(int k = 1; k < ringPart; k++) { 
      if(j != k) {
        physics.makeAttraction(net[i][j], net[i][k], -50, 1);
        println("spring" +j + "and" + k);
      }
     }
    }
  }
  
  
  smooth();
  controlP5 = new ControlP5(this);
  controlP5.setColorActive(color(255,0,0)); 
  
  myTextfield = controlP5.addTextfield("texts",10,20,200,20);
  myTextfield.setValue("Name");
  myTextfield.setLabel("Who you are...");
  myTextfield.setFocus(true);
  
  artistT = controlP5.addToggle("ARTIST",false,10,60,15,15);
  teacherT = controlP5.addToggle("TEACHER",false,80,60,15,15);
  studentT = controlP5.addToggle("STUDENT",false,150,60,15,15);
  curatorT = controlP5.addToggle("CURATOR",false,220,60,15,15);
  entrepT = controlP5.addToggle("ENTREPRENEUR",false,10,90,15,15);
  organT = controlP5.addToggle("ORGANIZER",false,80,90,15,15);
  inventT = controlP5.addToggle("INVENTOR",false,150,90,15,15);
  writerT = controlP5.addToggle("WRITER",false,220,90,15,15);
  controlP5.addTextlabel("occulabel", "What you do...", 10, 130);
  
  memorySpace = controlP5.addTextarea("memspace","", 10,200,200,300);
  myMemory = controlP5.addTextfield("memory", 10,160,200,20);
  myMemory.setLabel("What you remember...");
  myMemory.setValue("My favorite Dialog:City memory is ");
  controlP5.addButton("Submit", 1, 10, 510, 100, 20);
  
  textFont(font, 15);
}

void draw() {
  physics.tick();
  background(myColorBackground);
  /*fill(255, 255, 255, 20);
  for(int i = 0; i < name; i++) {
    beginShape();
    vertex(net[i][ringPart-1].position().x(), net[i][ringPart -1].position().y());
    for(int j = 1; j < ringPart; j++) {
      vertex(net[i][j].position().x(), net[i][j].position().y());
    }
    endShape();
  }
  */
  
  for(int i = 0; i < name; i++) {
    
    checkBounds(net[i][0]);
    for(int j = 1; j < ringPart; j++) {
      float sizer = random(5, 20);
      stroke(0, shaderG[i], shaderB[i]);
      line(net[i][j].position().x(), net[i][j].position().y(), net[i][0].position().x(), net[i][0].position().y());
      noFill();
      stroke(shaderG[i], 0, shaderB[i]);
      ellipse(net[i][j].position().x(), net[i][j].position().y(), sizer, sizer);
      checkBounds(net[i][j]);
    }
    fill(0);
    stroke(0, shaderG[i], shaderB[i]);
    ellipse(net[i][0].position().x(), net[i][0].position().y(), 50, 50);
    fill(255,255,255);
    text(textValue[i][0], net[i][0].position().x() - 20, net[i][0].position().y());
  }
  
  fill(30);
  noStroke();
  rect(10,200,200,300);
  fill(255, 20, 20);
  /*
  for(int j = 0; j < name; j++) {
    text(textValue[j][1], 300, 140 + (j*30)); 
  }
  */
  memorySpace.setText(myMemory.getText());
  
  net[int(random(centerPart))][int(random(ringPart))].addVelocity(random(-5,5), random(-10,10), 0);
  /*
  if(mousePressed) {
    for(int i = 0; i < centerPart; i++) {
      for(int j = 1; j < ringPart; j++) {
        if(dist(mouseX, mouseY, net[i][j].position().x(), net[i][j].position().y()) < 40) {
         net[i][j].addVelocity((mouseX-pmouseX), (mouseY - pmouseY), 0);
        }
      }
    } 
  }
  */
  
}



void Submit() {
  println("info submitted");
  textValue[name][0] = myTextfield.getText();
  textValue[name][1] = myMemory.getText();
  if(name < 100) {
    name++;
  }
  if(name%3 == 1) {
    String[] saver = new String[name * 3];
    int count = 0;
    for(int s = 0; s < name; s++) {
      saver[count] = textValue[s][0];
      count++;
      saver[count] = textValue[s][1];
      count++;
      saver[count] = textValue[s][2];
      count++;
    }
    saveStrings("lines.txt", saver);
  }
  
  myTextfield.setValue("Name");
  myMemory.setValue("My favorite Dialog:City memory is ");
  myTextfield.setFocus(true);
  artistT.setState(false);
  studentT.setState(false);
  teacherT.setState(false);
  curatorT.setState(false);
  entrepT.setState(false);
  organT.setState(false);
  inventT.setState(false);
  writerT.setState(false);
}

void ARTIST(boolean flag) {
  if(flag==true) {
    textValue[name][2] = textValue[name][2] + "1";
  }else{textValue[name][2] = textValue[name][2] + "0";
  }
}

void TEACHER(boolean flag) {
  if(flag==true) {
    textValue[name][2] = textValue[name][2] + "2";
  }else{textValue[name][2] = textValue[name][2] + "0";
  }
}

void STUDENT(boolean flag) {
  if(flag==true) {
    textValue[name][2] = textValue[name][2] + "3";
  }else{textValue[name][2] = textValue[name][2] + "0";
  }
}
void CURATOR(boolean flag) {
  if(flag==true) {
    textValue[name][2] = textValue[name][2] + "4";
  }else{textValue[name][2] = textValue[name][2] + "0";
  }
}
void ENTREPRENEUR(boolean flag) {
  if(flag==true) {
    textValue[name][2] = textValue[name][2] + "5";
  }
}
void ORGANIZER(boolean flag) {
  if(flag==true) {
    textValue[name][2] = textValue[name][2] + "6";
  }else{textValue[name][2] = textValue[name][2] + "0";
  }
}
void INVENTOR(boolean flag) {
  if(flag==true) {
    textValue[name][2] = textValue[name][2] + "7";
  }else{textValue[name][2] = textValue[name][2] + "0";
  }
}
void WRITER(boolean flag) {
  if(flag==true) {
    textValue[name][2] = textValue[name][2] + "8";
  }else{textValue[name][2] = textValue[name][2] + "0";
  }
}

void checkBounds(Particle a) {
  
  if(dist(a.position().x(),a.position().y(), mouseX, mouseY) < 20) {
   a.setVelocity( a.velocity().x() * -5, a.velocity().y() * -5, 0);
  }
  
  if(a.position().x() <= 0 ) {
   a.moveTo(1, a.position().y(), 0);
   a.setVelocity(a.velocity().x() * -1, a.velocity().y(), 0);
  }
  if(a.position().x() > width) {
   a.moveTo(width - 1, a.position().y(), 0);
   a.setVelocity(a.velocity().x() * -1, a.velocity().y(), 0);
  }
  if(a.position().y() <= 0 ) {
   a.moveTo(a.position().x(), 1, 0);
   a.setVelocity(a.velocity().x(), a.velocity().y() * -1, 0);
  }
  if(a.position().y() > height) {
   a.moveTo(a.position().x(), height - 1, 0);
   a.setVelocity(a.velocity().x(), a.velocity().y() * -1, 0);
  }
  
}
